#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1     //^C}[gpȂꍇ
#define TIME_UP 0       //^CAbv
#define LCD_WAIT 1
#define SHOW_WAIT 2000

#define LCD_RS_L IO_RB4_SetLow()
#define LCD_RS_H IO_RB4_SetHigh()
#define LCD_E_L IO_RB5_SetLow()
#define LCD_E_H IO_RB5_SetHigh()
#define LCD_B0_L IO_RB0_SetLow()
#define LCD_B0_H IO_RB0_SetHigh()
#define LCD_B1_L IO_RB1_SetLow()
#define LCD_B1_H IO_RB1_SetHigh()
#define LCD_B2_L IO_RB2_SetLow()
#define LCD_B2_H IO_RB2_SetHigh()
#define LCD_B3_L IO_RB3_SetLow()
#define LCD_B3_H IO_RB3_SetHigh()

#define FUNK_4BIT 0x28
#define FUNK_DSPON 0x0C
#define FUNK_DSPCLR 0x01
#define FUNK_ENTRY 0x06
#define FUNK_HOME 0x02
#define FUNK_LINE2_TOP (0x40 +0x80)

#define LCD_SZ 16

typedef enum{
    INIT_FUNK1=0,
    INIT_DSP,
    INIT_CLR,
    INIT_ENTRY,        
    INIT_MAX        
}INIT_LCD;

typedef enum{
    L_NO1 = 0,
    L_NO2,
    L_NO3,
    L_NO4,
    L_NO5,
    L_MAX  
}LCD_SHOW;

int16_t timLcdWait;
int16_t timShowWait;
int8_t initmd;
uint8_t cnt;
uint8_t showcnt;
uint8_t initmoji[2][16] ={"LCD-TEST By PIC ","         Ver1.00"};
uint8_t msg1[2][16] ={"Check   Data1   ","Current  123.56A"};
uint8_t msg2[2][16] ={"Check   Data2   ","Voltage  110.23V"};
uint8_t msg3[2][16] ={"CHECK Message1  ","I only drink tea"};
uint8_t msg4[2][16] ={"CHECK Message2  ","Thank you PIC!! "};

/* vg^Cv錾*/
void lcdInit(void);
void mainApp(void);
void mainTimer(void);
void LcdFuncSet0(uint8_t dat);
void LcdFuncSet(uint8_t dat);
void LcdMsgSet(uint8_t *msg);
void LcdHome(void);
void LcdClr(void);
void DspLine2Top(void);

/* Main application  */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    __delay_us(50);
    
    while(initmd != INIT_MAX){
        lcdInit();
    }
    
    while (1)
    {
        mainApp();
    }
}

/* TMR0I[o[t[荞݂ł̏  */
/* ^C}Ǘ֐ */
void mainTimer(void){
    
    if( timLcdWait > TIME_UP ){
      timLcdWait--;
    }
    
    if( timShowWait > TIME_UP ){
        timShowWait--;
    }
    
}
/* LCD̏ */
void lcdInit(void){
    
    switch(initmd){
        case INIT_FUNK1:
            if(timLcdWait == TIME_UP){
                timLcdWait = LCD_WAIT;
                LcdFuncSet0(FUNK_4BIT);
                if(++cnt >= 2){
                    ++initmd;
                }
            }
            break;
        case INIT_DSP:
            if(timLcdWait == TIME_UP){
                timLcdWait = LCD_WAIT;
                LcdFuncSet0(FUNK_DSPON);
                ++initmd;
            }
            break;
        case INIT_CLR:
            if(timLcdWait == TIME_UP){
                timLcdWait = LCD_WAIT;
                LcdFuncSet0(FUNK_DSPCLR);
                ++initmd;
            }
            break;
        case INIT_ENTRY:
            if(timLcdWait == TIME_UP){
                timLcdWait = LCD_WAIT;
                LcdFuncSet0(FUNK_ENTRY);
                ++initmd;
            }
            break;
    }
}
/* C */
void mainApp(void){

    if(timShowWait == TIME_UP){
       timShowWait = SHOW_WAIT;
       
       switch(showcnt){
            case L_NO1:
                LcdMsgSet(&initmoji[0][0]);           
                break;
            case L_NO2:
                LcdMsgSet(&msg1[0][0]); 
                break;
            case L_NO3:
                LcdMsgSet(&msg2[0][0]); 
                break;
            case L_NO4:
                LcdMsgSet(&msg3[0][0]); 
                break;
            case L_NO5:
                LcdMsgSet(&msg4[0][0]); 
                break;
       }
       
        if(++showcnt >= L_MAX){
            showcnt = L_NO1;
        }     
    }
}
/* Zbg */
void LcdMsgSet(uint8_t *msg){
    uint8_t i;
    
    LcdClr();
    //LcdHome();

    for(i=0;i < LCD_SZ; i++){
        //1LINE̕Zbg
        LcdFuncSet(msg[i]);
        __delay_us(80);
    }
    DspLine2Top(); //2iڂɃJ[\ړ
    for(i=0;i < LCD_SZ; i++){
        //2LINE̕Zbg
        LcdFuncSet(msg[i + LCD_SZ ]);
        __delay_us(80);
    }    
}
/* LCD̃J[\TOP */
void LcdHome(void){
    
    LcdFuncSet0(FUNK_HOME);
    __delay_us(2000);
}
/* ʃNA */
void LcdClr(void){

    LcdFuncSet0(FUNK_DSPCLR);
    __delay_us(2000);
}
/* LINE2̃gbvɃJ[\ */
void DspLine2Top(void){
    
    LcdFuncSet0(FUNK_LINE2_TOP);   
    __delay_us(80);    
}
/* IRɏ*/
void LcdFuncSet0(uint8_t dat){

    LCD_RS_L; //RSLOW
    
    if( dat & 0x80){
        LCD_B3_H; //IR7H
    }
    else{
        LCD_B3_L; //IR7L
    }
    
    if( dat & 0x40){
        LCD_B2_H; //IR6H
    }
    else{
        LCD_B2_L; //IR6L
    }
    
    if( dat & 0x20){
        LCD_B1_H; //IR5H
    }
    else{
        LCD_B1_L; //IR5L
    }
    
    if( dat & 0x10){
        LCD_B0_H; //IR4H
    }
    else{
        LCD_B0_L; //IR4L
    }  
    
    LCD_E_H; //EH
    __delay_us(1);
    LCD_E_L; //EL(f[^̊m)
    __delay_us(1);
    
    if( dat & 0x08){
        LCD_B3_H; //IR3H
    }
    else{
        LCD_B3_L; //IR3L
    }
    
    if( dat & 0x04){
        LCD_B2_H; //IR2H
    }
    else{
        LCD_B2_L; //IR2L
    }
    
    if( dat & 0x02){
        LCD_B1_H; //IR1H
    }
    else{
        LCD_B1_L; //IR1L
    }
    
    if( dat & 0x01){
        LCD_B0_H; //IR0H
    }
    else{
        LCD_B0_L; //IR0L
    }  
    
    LCD_E_H; //EH
    __delay_us(1);
    LCD_E_L; //EL(f[^̊m)
    __delay_us(1);    
    
}
/* DRɏ */
void LcdFuncSet(uint8_t dat){

    LCD_RS_H; //RSHIGH
    
    if( dat & 0x80){
        LCD_B3_H;
    }
    else{
        LCD_B3_L;
    }
    
    if( dat & 0x40){
        LCD_B2_H;
    }
    else{
        LCD_B2_L;
    }
    
    if( dat & 0x20){
        LCD_B1_H;
    }
    else{
        LCD_B1_L;
    }
    
    if( dat & 0x10){
        LCD_B0_H;
    }
    else{
        LCD_B0_L;
    }

    LCD_E_H;
    __delay_us(1);
    LCD_E_L;
    __delay_us(1);
    
    if( dat & 0x08){
        LCD_B3_H;
    }
    else{
        LCD_B3_L;
    }
    
    if( dat & 0x04){
        LCD_B2_H;
    }
    else{
        LCD_B2_L;
    }
    
    if( dat & 0x02){
        LCD_B1_H;
    }
    else{
        LCD_B1_L;
    }
    
    if( dat & 0x01){
        LCD_B0_H;
    }
    else{
        LCD_B0_L;
    }

    LCD_E_H;
    __delay_us(1);
    LCD_E_L;
    __delay_us(1);    
}

/**
 End of File
*/